
CoupledProblem = BiventricleCoarse #ohne J
CoupledProblem = DeformedBiventricleCoarse #mit J

Model = Coupled
CoupledModel = Segregated
#Model = Monodomain
#ElphyProblem=KovachevaBiventricleSimpleExcitationProblem
ActiveMaterial = Bonet #eigentlich Guccione
PassiveMaterial = Bonet #eigentlich Guccione
#Mittels Klotzkurve ermittelt:
GuccioneMat_C = 0.29
GuccioneMat_bf = 42.0
GuccioneMat_bs = 16.8
GuccioneMat_bfs = 29.4

# = Removes all files in the data folder upon start ======
ClearData = true
# ========================================================
# = Location of .geo files ===============================
GeoPath = ../geo/
# ========================================================
h0=1e-4
h_min=1e-6


activeStress = 0 #dann activeStrain verwendet


ProblemDimension = 3
ProblemGeometry = Tet

#Aublasen am Anfang und Druck ist an
WithPrestress=false #true  false
PrestressSteps = 10
PressureIterations = 20
PressureDepth = 0

LVPressure = 1.06658
RVPressure = 0.53329
RAPressure = 0
LAPressure = 0


#das wird in der LagrangeElasticity verwendet um zu entschieden, wie der Stretch geupdated wird
activeDeformation = Quarteroni2
#g = 0.8 #gamma for updateStretch
#scale_gamma = 0.8 #0.9, 1.0

withPressure = 1

deformConcentrationStretch = 0 #1
deformFibersInConductivity=true
WithGerachDiffsion=true

#Test um es schneller konvergieren zu lassen
timeStepExtrapolation = 0
DampExtrapolation = 0.5;


ElphyModelClass = MElphyModel
ElphyModelName = TenTusscher
TensionModelName = Rossi
RossiViscosity = 500
#RossiViscosity = 7000
RossiForce = 10
#RossiForce = 7

ElphyLevel = 0 #1
MechLevel = 0 #1
MechPolynomialDegree = 1
ElphyPolynomialDegree = 1

######################
#      Time          #
######################
StartTime = 0.0

EndTime=0.001
EndTime = 0.4
#EndTime = 0.8
#EndTime = 0.02

MechDeltaTime  = 0.001 #0.004# 0.001
ElphyDeltaTime = 0.001 # 0.001 #0.000001
DeltaTime = 0.0004 #spielt nur für Elektrophysiologie alleine eine Rolle
DeltaTimeMin = 0.00001
DeltaTimeMax = 0.001

######################
#      Plotting      #
######################
PlottingSteps = 10

#######################
#     Coupled Data    #
#######################
ClearDistribution = 0

MechDiscretization = Conforming
MechRuntype = Default
#MechDynamics = Newmark

## Rayleigh

MechDynamics = RayleighNewmark
RayleighAlpha = 100

##  KelvinVoigt

#MechDynamics = ViscoNewmark
#ViscoelasticDamping = KelvinVoigt
#KelvinVoigtEta = 2

#------------------------
# Newmark Parameters
#------------------------
# Damped Newmark
#NewmarkBeta = 0.3
#NewmarkGamma = 0.6
# Undamped Newmark
NewmarkBeta = 0.25
NewmarkGamma = 0.5

# If Iteration with Pressuresteps fails, recursively restart PressureSolver with Steps*2 until iteration limit is reached
PressureIterations = 10
PressureDepth = 0

######################
#       Meshes       #
######################
#muss gewählt werden:
#Mesh = TestBiventricle
Mesh=TestBiventricleSimpleExcitation_smooth
Mesh=KovacheveBiventricleSimpleExcitation_smooth
Mesh=KovachevaBiventricle
Mesh = TestBiventricle
#MechMeshPart = with_vessels
MechMeshPart = vessel_base
ElphyMeshPart = ventriclesonly
#für Boundary die gleitet
TractionK = 0#0.1
TractionC = 0#5e-3

#------------------------
# Stretch Parameters
#------------------------
StretchFactorSheet = 4.0
StretchFactorNormal = 4.0

#StretchFactorSheet = 2.0
#StretchFactorNormal = 5.0
######################
# Material Parameters#
######################
Density = 1082e-9 #roh in der Gleichung
#------------------------
# Volumetric Penalty
# Incompressible should be true or false
# Penalty Types: None, Ciarlet, Mixed
#------------------------
VolumetricSplit = 0
Incompressible = false
QuasiCompressiblePenalty = Ciarlet #None, Ciarlet, Mixed
VolumetricPenalty = 1000 # ?
PermeabilityPenalty = 0 #1000 # ?


ElphyModel = SemiImplicit
ElphyModel = SemiImplicitOnCells
OrderStaggeredScheme = wcV
ReassembleRHSonce = 1

ElphySplittingMethod =Godunov
#Iext splitted in PDE =1, Iext in ODE =0
IextInPDE=1

#Glaettung von Anregung  in Zeit: Stepfunction,Arctan,Tanh
ExternalCurrentSmoothingInTime = Arctan#Arctan #Stepfunction
#Glättung Anregung im Raum: discrete, linear
ExternalCurrentSmoothingInSpace = linear




# Monodomain Parameters
SurfaceToVolumeRatio= 140#1/mm
MembraneCapacitance=0.01#muF/mm^2

IntraLongitudinal = 0.170 #0
ExtraLongitudinal = 0.620
IntraTransversal = 0.019
ExtraTransversal = 0.240  #0

ElphyIntegrator=ExplicitEuler
CellModelScheme = ExponentialIntegrator
IonScheme = Quadratic # ExplicitEuler,RungeKutta2,RungeKutta4

ThresholdVForActivation=-50.0

EulerReAssemble = 0

SetSolution = 0 #falls man ne exakte Lösung

# === Linear Solver === #
LinearSolver = gmres
LinearEpsilon = 1e-8
LinearReduction = 1e-8
LinearReduction = 1e-11
LinearSteps = 10000
#LinearPrintSteps = 1000
BasePreconditioner = GaussSeidel
Preconditioner = GaussSeidel
Preconditioner = LIB_PS

# =================================================================
# === Gating Solver ===============================================
GatingSolver = gmres
GatingPreconditioner = GaussSeidel
GatingEpsilon = 1e-8
GatingReduction = 1e-12

# === Elphy Solver ================================================
ElphySolver = gmres
ElphyPreconditioner=Jacobi
ElphyEpsilon = 1e-6
ElphyReduction = 1e-10

# === Mechanics Solver ============================================
MechSolver = gmres
MechPreconditioner = GaussSeidel
MechEpsilon = 1e-10
MechReduction = 1e-10 #1e-12
MechSteps = 20000

# === Newton Method === #
NewtonEpsilon = 1e-5 #1e-8
NewtonReduction = 1e-12 #1e-5
NewtonSteps = 100
NewtonLineSearchSteps = 10
NewtonLinearizationReduction = 1e-4 #1e-12

#Smoother = GaussSeidel
#Smoother = PointBlockGaussSeidel
#SmootherDamp = 0.9
presmoothing = 3
postsmoothing = 3

ConfigVerbose = 1
AssembleVerbose = 1

# = Solver Verbose =
MultigridVerbose = 0
BaseSolverVerbose = -1
LinearVerbose = -5
NewtonVerbose = -1
EulerVerbose = 0
LinearImplicitVerbose = 1
ElphyLinearSolverVerbose =-1
MonodomainVerbose =1
NonLinearVerbose = -5
ElphySolverVerbose = 1
CoupledSolverVerbose = 4
CellModelVerbose = 0

# = Main Verbose =
ElphyVerbose = 1
MechVerbose = 1
PrintVSteps = 1


#####################################
#CoupledSolverVTK
#####################################
ParallelPlotting=False
Compression=ascii

# = Plot Verbose =
ElphyVTK = 1 # 0 Disables all plots from Electrophysiology
MechVTK = -1 # 0 Disables all plots from Elasticity

# = Plot Verbose =
PressureSolverVTK = 0
DynamicSolverVTK = -10
ElphySolverVTK = 10
CoupledSolverVTK = -10
PlotCalcium=0
PlotVTK = -1